/*
 * LabGPIO.c
 *
 *  Created on: Feb 13, 2018
 *      Author: Ryan
 */

#include <LabGPIO.h>

void gpio_x__set_as_input(uint8_t port_num, uint8_t pin_num)
{
    if(port_num == 0)
    {
        LPC_GPIO0->DIR &= ~(1 << pin_num);
    }
    else if(port_num == 1)
    {
        LPC_GPIO1->DIR &= ~(1 << pin_num);
    }
    else if(port_num == 2)
    {
        LPC_GPIO2->DIR &= ~(1 << pin_num);
    }
    else if(port_num == 3)
    {
        LPC_GPIO3->DIR &= ~(1 << pin_num);
    }
    else if(port_num == 4)
    {
        LPC_GPIO4->DIR &= ~(1 << pin_num);
    }
    else
    {
        LPC_GPIO5->DIR &= ~(1 << pin_num);
    }
}

/// Should alter the hardware registers to set the pin as output
void gpio_x__set_as_output(uint8_t port_num, uint8_t pin_num)
{
    if(port_num == 0)
    {
        LPC_GPIO0->DIR |= (1 << pin_num);
    }
    else if(port_num == 1)
    {
        LPC_GPIO1->DIR |= (1 << pin_num);
    }
    else if(port_num == 2)
    {
        LPC_GPIO2->DIR |= (1 << pin_num);
    }
    else if(port_num == 3)
    {
        LPC_GPIO3->DIR |= (1 << pin_num);
    }
    else if(port_num == 4)
    {
        LPC_GPIO4->DIR |= (1 << pin_num);
    }
    else
    {
        LPC_GPIO5->DIR |= (1 << pin_num);
    }
}

/// Should alter the hardware registers to set the pin as high
void gpio_x__set_high(uint8_t port_num, uint8_t pin_num)
{
    if(port_num == 0)
    {
        LPC_GPIO0->SET = (1 << pin_num);
    }
    else if(port_num == 1)
    {
        LPC_GPIO1->SET = (1 << pin_num);
    }
    else if(port_num == 2)
    {
        LPC_GPIO2->SET = (1 << pin_num);
    }
    else if(port_num == 3)
    {
        LPC_GPIO3->SET = (1 << pin_num);
    }
    else if(port_num == 4)
    {
        LPC_GPIO4->SET = (1 << pin_num);
    }
    else
    {
        LPC_GPIO5->SET = (1 << pin_num);
    }
}

/// Should alter the hardware registers to set the pin as low
void gpio_x__set_low(uint8_t port_num, uint8_t pin_num)
{
    if(port_num == 0)
    {
        LPC_GPIO0->CLR = (1 << pin_num);
    }
    else if(port_num == 1)
    {
        LPC_GPIO1->CLR = (1 << pin_num);
    }
    else if(port_num == 2)
    {
        LPC_GPIO2->CLR = (1 << pin_num);
    }
    else if(port_num == 3)
    {
        LPC_GPIO3->CLR = (1 << pin_num);
    }
    else if(port_num == 4)
    {
        LPC_GPIO4->CLR = (1 << pin_num);
    }
    else
    {
        LPC_GPIO5->CLR = (1 << pin_num);
    }
}
    
/**
 * Should alter the hardware registers to set the pin as low
 *
 * @param {bool} high - true => set pin high, false => set pin low
 */
void gpio_x__set(uint8_t port_num, uint8_t pin_num, bool high)
{
    if(high == true)
    {
        gpio_x__set_high(port_num, pin_num);
    }
    else
    {
        gpio_x__set_low(port_num, pin_num);
    }
}
    
/**
 * Should return the state of the pin (input or output, doesn't matter)
 *
 * @return {bool} level of pin high => true, low => false
 */
bool gpio_x__get_level(uint8_t port_num, uint8_t pin_num)
{
    bool pin_state = false;

    if(port_num == 0)
    {
        if(LPC_GPIO0->PIN & (1 << pin_num))
        {
            pin_state = true;
        }

        else
        {
            pin_state = false;
        }
    }
    else if(port_num == 1)
    {
        if(LPC_GPIO1->PIN & (1 << pin_num))
        {
            pin_state = true;
        }

        else
        {
            pin_state = false;
        }
    }
    else if(port_num == 2)
    {
        if(LPC_GPIO2->PIN & (1 << pin_num))
        {
            pin_state = true;
        }

        else
        {
            pin_state = false;
        }
    }
    else if(port_num == 3)
    {
        if(LPC_GPIO3->PIN & (1 << pin_num))
        {
            pin_state = true;
        }

        else
        {
            pin_state = false;
        }
    }
    else if(port_num == 4)
    {
        if(LPC_GPIO4->PIN & (1 << pin_num))
        {
            pin_state = true;
        }

        else
        {
            pin_state = false;
        }
    }
    else if(port_num == 5)
    {
        if(LPC_GPIO5->PIN & (1 << pin_num))
        {
            pin_state = true;
        }

        else
        {
            pin_state = false;
        }
    }

    return pin_state;
}