/*
 * LabSPI.cpp
 *
 *  Created on: Mar 7, 2018
 *      Author: Ryan
 */

#include <LabSPI.h>
#include <gpio.h>
#include "lpc_peripherals.h"

void ssp__init(uint32_t max_clock_mhz)
{
    //uint8_t divider = 2;
    //const uint32_t cpu_clock_mhz = clock__get_core_clock_hz() / 1000000UL;

    //LPC_SC->PCONP |= (UINT32_C(1) << 21);

    lpc_peripheral__turn_on_power_to(LPC_PERIPHERAL__SSP2);
    LPC_SSP2->CR0 = 7;
    LPC_SSP2->CR1 = (1 << 1);

    gpio__construct_with_function(GPIO__PORT_1, 0, GPIO__FUNCTION_4);
    gpio__construct_with_function(GPIO__PORT_1, 1, GPIO__FUNCTION_4);
    gpio__construct_with_function(GPIO__PORT_1, 4, GPIO__FUNCTION_4);
    //LPC_IOCON->P0_15 |= (1 << 1);
    //LPC_IOCON->P0_17 |= (1 << 1);
    //LPC_IOCON->P0_18 |= (1 << 1);

    //while (max_clock_mhz < (cpu_clock_mhz / divider) && divider <= 254)
    //{
    //    divider += 2;
    //}

  LPC_SSP2->CPSR = 4;
}

uint8_t ssp__exchange_byte(uint8_t data_out)
{
    LPC_SSP2->DR = data_out;

  while (LPC_SSP2->SR & (1 << 4))
  {
    ;//vTaskDelay(1);
  }

  return (uint8_t)(LPC_SSP2->DR & 0xFFFF);
}