///*
// *     SocialLedge.com - Copyright (C) 2013
// *
// *     This file is part of free software framework for embedded processors.
// *     You can use it and/or distribute it as long as this copyright header
// *     remains unmodified.  The code is free for personal use and requires
// *     permission to use in a commercial product.
// *
// *      THIS SOFTWARE IS PROVIDED "AS IS".  NO WARRANTIES, WHETHER EXPRESS, IMPLIED
// *      OR STATUTORY, INCLUDING, BUT NOT LIMITED TO, IMPLIED WARRANTIES OF
// *      MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE.
// *      I SHALL NOT, IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL, OR
// *      CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
// *
// *     You can reach the author of this software at :
// *          p r e e t . w i k i @ g m a i l . c o m
// */
//
///**
// * @file
// * @brief This is the application entry point.
// */
//

#include <FreeRTOS.h>
#include <task.h>
#include <lpc40xx.h>
#include <clock.h>
#include "labGPIO.h"
#include "labSPI.h"
#include "MP3DecoderDriver.h"
#include <stdio.h>
#include <stdlib.h>
#include "ff.h"

QueueHandle_t MP3Queue;

void readMP3File()//const char* pFilename,  void* pData, unsigned int bytesToRead, unsigned int offset
{

   //Got all file names in directory!

        //FRESULT mountstatus;
        FRESULT findstatus;
        FRESULT readstatus;
        int feofstatus;
        static FIL mp3file;
        //FATFS myFileSystem; //my work area (filesystem object).
        const char *filename = "gamesong.mp3";
        int read_size = 512;
        BYTE buffer[read_size];
        UINT filereadbytescount;//dont know what this does yet.
	
        //mountstatus = f_mount((FATFS*)&myFileSystem, (const char*)"1:", 1);//force mount the drive.
        
        findstatus = f_open (&mp3file, filename, FA_OPEN_EXISTING | FA_READ);
        readstatus = f_read(&mp3file, buffer, read_size, &filereadbytescount);
        feofstatus = f_eof(&mp3file);
        //printf("findstatus = %d\n", findstatus);
        //printf("readstatus = %d\n", readstatus);
        //printf("feofstatus = %d\n", feofstatus);
        while (findstatus == FR_OK && feofstatus != 1)
        {
                //printf("findstatus succesful\n");
                feofstatus = f_eof(&mp3file);
                if (readstatus == FR_OK)
                {
                        //printf ("%i\n", readstatus);
                        //printf ("%i\n", filereadbytescount);
                        //printf ("%s\n", buffer);
                        if (xQueueSend(MP3Queue, buffer, portMAX_DELAY))
                        {
                        //printf ("Data sent.\n");
                        }
                        readstatus = f_read(&mp3file, buffer, read_size, &filereadbytescount);
                }
        }   //This for loop will constantly send data from the SD card to MP3 Decoder based on file paths in playlist array.
}

void Read_MP3_Task(void *pvParameters)
{
        while(1)
        {
                readMP3File();
                vTaskDelay(1000);
        }
}

void MP3_Play_Task(void *pvParameters)
{
        BYTE decoder_buffer[512];
        mp3_decoder_init();

        while(1)
        {
                if(xQueueReceive(MP3Queue, decoder_buffer, 1000))
                {
                        //printf("track playing");
                        play_mp3_track(decoder_buffer);
                }
        }
}

int main(int argc, char const *argv[])
{
        //uart__init(UART__0, clock__get_peripheral_clock_hz(), 115200);
        const uint32_t STACK_SIZE_WORDS = 1024;
        MP3Queue = xQueueCreate(1, 512);
        //TaskHandle_t xHandle = NULL;
        //printf(stdout, "Hello World\n");

        xTaskCreate(Read_MP3_Task, (const char*) "Read MP3 Task", STACK_SIZE_WORDS, (void *) 1, 1, NULL);
        xTaskCreate(MP3_Play_Task, (const char*) "MP3 Play Task", STACK_SIZE_WORDS, (void *) 1, 1, NULL);
        vTaskStartScheduler();
}

/*Lab 5 SPI

#include <lpc40xx.h>
#include <clock.h>
#include <uart.h>
#include <uart_printf.h>

void ssp2__init(uint32_t max_clock_mhz) {
  // Refer to LPC User manual and setup the register bits correctly
  // a) Power on Peripheral
  // b) Setup control registers CR0 and CR1
  // c) Setup prescalar register to be <= max_clock_mhz
        uint8_t prescalar_divider = 2;
        const uint32_t cpu_clock = clock__get_core_clock_hz();

        LPC_SC->PCONP |= (1 << 20);
        LPC_IOCON->P1_0 = 4;
        LPC_IOCON->P1_1 = 4;
        LPC_IOCON->P1_4 = 4;
        LPC_IOCON->P1_8 = 4;
        LPC_SSP2->CR0 = 7;
        LPC_SSP2->CR1 |= (1 << 1);
        while(max_clock_mhz < (cpu_clock / prescalar_divider) && prescalar_divider <= 254) {
                prescalar_divider += 2;
        }
        LPC_SSP2->CPSR = prescalar_divider;
}

uint8_t ssp2__exchange_byte(uint8_t data_out) {
  // Configure the Data register(DR) to send and receive data by checking the status register
        LPC_SSP2->DR = data_out;
        while(LPC_SSP2->SR & (1 << 4)) {
        }
        return (uint8_t)(LPC_SSP2->DR & 0xFF);
}

void ssp_test(void *pvParameters) {
        uint8_t dev_id;
        ssp2__init(96);
        dev_id = ssp2__exchange_byte(0x9F);
        uart_puts(UART__0, dev_id);
        dev_id = ssp2__exchange_byte(0xFF);
        uart_puts(UART__0, dev_id);
        dev_id = ssp2__exchange_byte(0xFF);
        uart_puts(UART__0, dev_id);
        dev_id = ssp2__exchange_byte(0xFF);
        uart_puts(UART__0, dev_id);
}

int main() {
        const uint32_t STACK_SIZE_WORDS = 1024;
        TaskHandle_t xHandle = NULL;

        xTaskCreate(ssp_test, "ssp_test_task", STACK_SIZE_WORDS, (void *) 0, 1, &xHandle);
        vTaskStartScheduler();

        return 0;
}*/

/*Lab 1

#include "FreeRTOS.h"
#include "task.h"
#include "LabGPIO.h"
#include "L0_Platform/lpc40xx/LPC40xx.h"

bool SwitchReleaseInt = false;
bool SwitchReleaseExt = false;

void vControlLED(void *pvParameters) {
        uint32_t Led = (uint32_t)(pvParameters);

        LabGPIO LED0(2, 3);
        LabGPIO LEDE(0, 1);
        //LabGPIO LEDP(0, 7);

        LED0.setDirection(1);
        LEDE.setDirection(1);

        while(1) {
                if(Led == 0) {
                        LED0.set(1);
                        if(SwitchReleaseInt) {
                                LED0.set(0);
                                vTaskDelay(1000);
                                LED0.set(1);
                                SwitchReleaseInt = false;
                        }
                }
                else if(Led == 1) {
                        LEDE.set(1);
                        if(SwitchReleaseExt) {
                                LEDE.set(0);
                                vTaskDelay(1000);
                                LEDE.set(1);
                                SwitchReleaseExt = false;
                        }
                }
                vTaskDelay(100);
        }
        vTaskDelete(NULL);
}

void vReadSwitch(void *pvParameters) {
        uint32_t Switch = (uint32_t)(pvParameters);

        bool switch_press0 = false;
        bool switch_press1 = false;

        LabGPIO SWITCH0(0, 30);
        LabGPIO SWITCH1(1, 15);

        SWITCH0.setDirection(0);
        SWITCH1.setDirection(0);

        while(1) {
                if(Switch == 0) {
                        if(SWITCH0.getLevel()) {
                                switch_press0 = true;
                        }
                        if(!SWITCH0.getLevel() && switch_press0 == true) {
                                SwitchReleaseInt = true;
                                switch_press0 = false;
                        }
                }
                else if(Switch == 1) {
                        if(SWITCH1.getLevel()) {
                                switch_press1 = true;
                        }
                        if(!SWITCH1.getLevel() && switch_press1 == true) {
                                SwitchReleaseExt = true;
                                switch_press1 = false;
                        }
                }
                vTaskDelay(100);
        }
        vTaskDelete(NULL);
}

int main() {
        const uint32_t STACK_SIZE_WORDS = 1024;
        TaskHandle_t xHandle = NULL;

        xTaskCreate(vControlLED, "internal_led_task", STACK_SIZE_WORDS, (void *) 0, 6, &xHandle);
        xTaskCreate(vReadSwitch, "internal_switch_task", STACK_SIZE_WORDS, (void *) 0, 3, &xHandle);

        xTaskCreate(vControlLED, "external_led_task", STACK_SIZE_WORDS, (void *) 1, 5, &xHandle);
        xTaskCreate(vReadSwitch, "external_switch_task", STACK_SIZE_WORDS, (void *) 1, 2, &xHandle);

        vTaskStartScheduler();

        return 0;
}
*/

/*Lab 1: Multiple Tasks

#include "FreeRTOS.h"
#include "task.h"
#include "uart_printf.h"
#include "uart.h"
#include "stdio.h"

void vTaskOneCode(void *p)
{
    while(1)
    {
        uart__init(UART__0, 96000000, 38400);
        uart_puts(UART__0, "aaaaaaaaa");
        //printf("aaaaaaaaa");
    	vTaskDelay(100); // This sleeps the task for 100ms (because 1 RTOS tick = 1 millisecond)
    }
}

// Create another task and run this code in a while(1) loop
void vTaskTwoCode(void *p)
{
    while(1)
    {
        uart__init(UART__1, 96000000, 38400);
        uart_puts(UART__1, "bbbbbbbbb");
        //printf("bbbbbbbbb");
    	vTaskDelay(100);
    }
}

// You can comment out the sample code of lpc1758_freertos project and run this code instead
int main(int argc, char const *argv[])
{
    /// This "stack" memory is enough for each task to run properly (512 * 32-bit) = 2Kbytes stack
    const uint32_t STACK_SIZE_WORDS = 512;
  
     // Observe and explain the following scenarios:
     //
     // 1) Same Priority: A = 1, B = 1
     // 2) Different Priority: A = 2, B = 1
     // 3) Different Priority: A = 1, B = 2
     //
     // Turn in screen shots of what you observed
     // as well as an explanation of what you observed

    xTaskCreate(vTaskOneCode, "Task One", STACK_SIZE_WORDS, (void *) 1, 1, NULL);
    xTaskCreate(vTaskTwoCode, "Task Two", STACK_SIZE_WORDS, (void *) 1, 1, NULL);

    // Start Scheduler - This will not return, and your tasks will start to run their while(1) loop
    vTaskStartScheduler();

    return 0;
}*/

/*#include <stdio.h>

#include "FreeRTOS.h"
#include "task.h"

#include "board_io.h"
#include "delay.h"
#include "gpio.h"

static void blink_task(void *params);
static void uart_task(void *params);
static void blink_on_startup(gpio_s gpio, int count);

static gpio_s led0, led1;

int main(void) {
  // Construct the LEDs and blink a startup sequence
  led0 = board_io__get_led0();
  led1 = board_io__get_led1();
  blink_on_startup(led1, 2);

  xTaskCreate(blink_task, "led0", (512U / sizeof(void *)), (void *)&led0, PRIORITY_LOW, NULL);
  xTaskCreate(blink_task, "led1", (512U / sizeof(void *)), (void *)&led1, PRIORITY_LOW, NULL);

  // printf() takes more stack space, size this tasks' stack higher
  xTaskCreate(uart_task, "uart", (512U * 8) / sizeof(void *), NULL, PRIORITY_LOW, NULL);

  puts("Starting RTOS");
  vTaskStartScheduler(); // This function never returns unless RTOS scheduler runs out of memory and fails

  return 0;
}

static void blink_task(void *params) {
  const gpio_s led = *((gpio_s *)params);

  while (true) {
    gpio__toggle(led);
    vTaskDelay(500);
  }
}

// This sends periodic messages over printf() which uses system_calls.c to send them to UART0
static void uart_task(void *params) {
  TickType_t previous_tick = 0;
  long ticks = 0;

  while (true) {
    // This loop will repeat at precise task delay, even if the logic below takes variable amount of ticks
    vTaskDelayUntil(&previous_tick, 2000);

    // Calls to fprintf(stderr, ...) uses polled UART driver, so this entire output will be fully sent out
    // before this function returns. See system_calls.c for actual implementation.
    // This is useful to print information inside of interrupts as you cannot use printf() inside an ISR
    //
    ticks = xTaskGetTickCount();
    fprintf(stderr, "This is a polled version of printf used for debugging ... finished in");
    fprintf(stderr, " %lu ticks\n", (xTaskGetTickCount() - ticks));

    // This deposits data to an outgoing queue and doesn't block the CPU
    // Data will be sent later, but this function would return earlier
    //
    ticks = xTaskGetTickCount();
    printf("This is a more efficient printf ... finished in");
    printf(" %lu ticks\n\n", (xTaskGetTickCount() - ticks));
  }
}

static void blink_on_startup(gpio_s gpio, int blinks) {
  const int toggles = (2 * blinks);
  for (int i = 0; i < toggles; i++) {
    delay__ms(250);
    gpio__toggle(gpio);
  }
}*/
